#ifndef lint
static char *RCSid = "$Header: /usr/brule/guest/empire/empire/emprcs/lib/subs/caploss.c,v 2.4 1995/10/22 20:49:21 empire Exp $";
#endif

/*
 * caploss.c
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "player.h"
#include "nat.h"
#include "var.h"
#include "sect.h"
#include "file.h"
#include "xy.h"
#include "news.h"
#include "path.h"
#include "edb.h"
#include "loan.h"
#include "commodity.h"

void
caploss(sp, coun, msg)
	struct	sctstr *sp;
	natid	coun;
	s_char	*msg;
{
	struct	natstr *natp;
	struct  lonstr loan;
	struct  comstr comm;
	long	lose;
	long	gain;
	struct	sctstr sect;
	int	n;
	int loan_num = 0;
	int comm_num = 0;

	natp = getnatp(coun);
	if ((xrel(natp,natp->nat_xcap) != xrel(natp,sp->sct_x)) ||
	      (yrel(natp,natp->nat_ycap) != yrel(natp,sp->sct_y)))
	     return;
	pr(msg, natp->nat_cnam);
	if (coun == player->cnum) {
		player->nstat &= ~CAP;
		return;
	}
	if (sp->sct_updated == 1){
		gain = lose = natp->nat_money / 2;
		if (lose < 3000)
			lose = 3000;
		n = roll(6);
		getsect(sp->sct_x + diroff[n][0],
			sp->sct_y + diroff[n][1],
			&sect);
		natp->nat_xcap = sect.sct_x;
		natp->nat_ycap = sect.sct_y;
		natp->nat_money -= lose;
		putnat(natp);
		prsync(natp->nat_cnum, natp, EDV_ALL);
		wu(0, coun,
		   "* %s just sacked your capital! *\n",
		   cname(player->cnum));
		   
		if (gain >= 0)  {
			gain = (0.2 + 0.8 * (sp->sct_effic/100.0)) * gain;
			player->dolcost -= gain;
		} else
			gain = 0;
		wu(0, coun,
		   "You lost $%d and they gained $%d\n",
		   lose, gain);
		wu(0, coun,
		   "Your capital has been moved to %s\n",
		   xyas(natp->nat_xcap, natp->nat_ycap, coun));
		wu(0, 0, "%s just took %s's capital and gained $%d\n",
			cname(player->cnum), cname(coun),
			-(int)(player->dolcost));
#ifdef LOANS
                for (loan_num = 0; getloan(loan_num, &loan); loan_num++) {
                    if (loan.l_ldur != 0 && loan.l_loner == coun) {
                        loan.l_loner = player->cnum;
                        putloan(loan_num, &loan);
                        pr("Loan %d has been transfered over to you\n",
                           loan_num);
                    }
                }
#endif /* LOANS */
#ifdef MARKET
                for (comm_num = 0; getcomm(comm_num, &comm); comm_num++) {
                    if (comm.com_owner == coun) {
                        if (comm.com_owner == comm.com_maxbidder)
                            comm.com_maxbidder = player->cnum;
                        comm.com_owner = player->cnum;
                        putcomm(comm_num, &comm);
                        pr("You now own commodity #%d.\n",
                           comm_num);
                    }
                }
#endif /* MARKET */
		nreport(player->cnum, N_SACK_CAP, coun, 1);
		sp->sct_updated = 0;
	}
}
